
#include "modbus.h"

int pu_write(char *com_namb, int reg)
{
	modbus_t	*mb;
	int			chek;
	int			rc;

	chek = 1;
	mb = modbus_new_rtu(com_namb, 9600, 'N', 8, 1); //      modbus
	if (mb == NULL)
	{
		modbus_free(mb);
		return (-1);
	}
	rc = modbus_set_slave(mb, 0x0A);
	if (rc != 0) 
	{
		modbus_free(mb);
		return (-2);
	}
	chek = modbus_connect(mb); //          
	if (chek == 0)
	{
		rc = modbus_write_register(mb,0,reg); //          
		if (rc != 1) 
		{
			modbus_free(mb);
			return (-4);
		}
		modbus_close(mb);
	}
	else
	{
		modbus_free(mb);
		return (-3);
	}
	modbus_free(mb);
	return (0);
}

int pu_read(char *com_namb, uint16_t tab_reg[6])
{
	modbus_t	*mb;
	int			chek;
	int			rc;

	chek = 1;
	mb = modbus_new_rtu(com_namb, 9600, 'N', 8, 1); //      modbus
	if (mb == NULL)
	{
		modbus_free(mb);
		return (-1);
	}
	rc = modbus_set_slave(mb, 0x0A);
	if (rc != 0) 
	{
		modbus_free(mb);
		return (-2);
	}
	chek = modbus_connect(mb); //          
	if (chek == 0)
	{
		rc = modbus_read_registers(mb, 0, 6, tab_reg); //         
		if (rc <= 0) 
		{
			modbus_free(mb);
			return (-4);
		}
		modbus_close(mb);
	}
	else
	{
		modbus_free(mb);
		return (-3);
	}
	modbus_free(mb);
	return (0);
}

int pu_on(char *com_namb)
{
	int reg;

	reg = 2;
	return (pu_write(com_namb, reg));
}

int pu_off(char *com_namb)
{
	int reg;

	reg = 1;
	return (pu_write(com_namb, reg));
}

int pu_otbor(char *com_namb)
{
	int reg;

	reg = 3;
	return (pu_write(com_namb, reg));
}

int pu_stop(char *com_namb)
{
	int reg;

	reg = 4;
	return (pu_write(com_namb, reg));
}

int pu_set_50(char *com_namb)
{
	int reg;

	reg = 50;
	return (pu_write(com_namb, reg));
}

int pu_set_100(char *com_namb)
{
	int reg;

	reg = 100;
	return (pu_write(com_namb, reg));
}

int pu_set_250(char *com_namb)
{
	int reg;

	reg = 250;
	return (pu_write(com_namb, reg));
}

int pu_set_500(char *com_namb)
{
	int reg;

	reg = 500;
	return (pu_write(com_namb, reg));
}

int pu_set_1000(char *com_namb)
{
	int reg;

	reg = 1000;
	return (pu_write(com_namb, reg));
}